import Cordova
import Cordova
import Foundation
import SafariServices
import os.log
import UIKit


struct trackObj: Codable {
    var title: String!
    var artist: String!
    var artistUri: String!
    var albumUri: String!
    var album: String!
    var trackUri: String!
    var accessToken: String!
    var expiresAt: Int!
    //let testNum: Int = 10
   
    init(title: String, artist: String, artistUri: String, albumUri: String, trackUri: String, album: String){
        self.title = title
        self.artist = artist
        self.artistUri = artistUri
        self.albumUri = albumUri
        self.album = album
        self.trackUri = trackUri
    }
  
}



let PLAY = 4;
let PAUSE = 5;
let RESUME = 123;
let SKIPNEXT = 6;
let SKIPBACK = 7;
let PLAYQUEUE = 8;
let QUEUELIST = 9;
let QUEUESONG = 10;
let ADDLIBRARY = 11;
let REMOVEFROMLIBRARY = 12;
let CONNECT = 1000;

var waitForConnect = false;
var qdCommand = 0;


var expiresAt: Int!
var playURI: String = "";
var qTrackURIs: [String] = []
var qIterator = 0;

var authorized = false;
var test = false;
let SpotifyClientID = "106d1236ac7e49f2ba9b79cefb415225"
let SpotifyClientSecret = "db37c00cb6fe4fe5bf6eb38924eca8fa"
let SpotifyRedirectURL = URL(string: "latitunes://")!
var currentTrack: trackObj!
var cdvCallbackId: String!
var albumCover: UIImage!
var pluginResult = CDVPluginResult(
   status: CDVCommandStatus_ERROR
   )

var freshReturn = false;

let stringScopes = [
"user-read-playback-state", "user-modify-playback-state", "user-read-currently-playing",
"streaming", "app-remote-control",
"user-library-modify", "user-library-read",
"user-top-read"]
//@UIApplicationMain
@objc(CordovaSpotifyRemote) class CordovaSpotifyRemote: CDVPlugin, UIApplicationDelegate, SPTAppRemoteDelegate, SPTAppRemotePlayerStateDelegate, SPTSessionManagerDelegate{
    
    var responseTypeCode: String? {
      didSet {
        fetchSpotifyToken { (dictionary, error) in
          if let error = error {
            print("Fetching token request error \(error)")
            return
          }
          let accessToken = dictionary!["access_token"] as! String
          DispatchQueue.main.async {
            self.appRemote.connectionParameters.accessToken = accessToken
            self.appRemote.connect()
          }
        }
      }
    }
    
    var accessToken: String!
    static let shared = CordovaSpotifyRemote();
//    
    //Spotify Objects
    var currentPlayerState: SPTAppRemotePlayerState?
    lazy var configuration: SPTConfiguration = {
        let configuration:SPTConfiguration = SPTConfiguration(clientID: SpotifyClientID, redirectURL: SpotifyRedirectURL)
        configuration.playURI = ""
        configuration.tokenRefreshURL = URL(string: "https://latitunes.herokuapp.com/refresh")!
        configuration.tokenSwapURL = URL(string: "https://latitunes.herokuapp.com/swap")!
        return configuration
        }()

    lazy var sessionManager: SPTSessionManager = {
        let manager = SPTSessionManager(configuration: self.configuration, delegate: self)
        return manager
    }()
    lazy var appRemote: SPTAppRemote = {
       let appRemote = SPTAppRemote(configuration: self.configuration, logLevel: .debug)
       appRemote.connectionParameters.accessToken = accessToken
       appRemote.delegate = self
       return appRemote
     }()
   
    var qTracksCallback:  SPTAppRemoteCallback {
            get {
                return {[weak self] _, error in
                    if error != nil {
                      print("default error")
                    }else{
                        if(qTrackURIs.count-1 > qIterator){
                            qIterator += 1
                            self?.queueNPlay()
                        }
                    }
                }
            }
        }
     var defaultCallback: SPTAppRemoteCallback {
         get {
             return {[weak self] _, error in
                 if error != nil {
                   print("default error")
                 }
             }
         }
     }
    var window: UIWindow?
 

    
    
    func sessionManager(manager: SPTSessionManager, didInitiate session: SPTSession) {
        print("^R^ session did initiate");
        self.appRemote.connectionParameters.accessToken = accessToken
              
              SPTAppRemote.checkIfSpotifyAppIsActive { isActive in
                  if isActive {
                      self.appRemote.connect()
                  } else {
                      self.appRemote.authorizeAndPlayURI("")
                  }
        }
    }
     
     func sessionManager(manager: SPTSessionManager, didFailWith error: Error) {
         print("^R^ session errored");
         print(error)
     }
    func sessionManager(manager: SPTSessionManager, didRenew session: SPTSession) {
        print("^R^ session did renew");
         print(session)
     }
     
   /*Overidden SPTAppRemoteDelegate methods--------------------------------------------------------------------------------------*/
    func appRemote(_ appRemote: SPTAppRemote, didDisconnectWithError error: Error?) {
         os_log("xxx disconnected");
    }
    func appRemote(_ appRemote: SPTAppRemote, didFailConnectionAttemptWithError error: Error?) {
        print("^R^ remote errored");
        os_log("xxx failed");
//        if(waitForConnect){
//            waitForConnect = false;
//            appRemote.authorizeAndPlayURI("")
//        }
    }
    func appRemoteDidEstablishConnection(_ appRemote: SPTAppRemote) {
        // Connection was successful, you can begin issuing commands
        print("^R^ Remote did connect");
//          self.appRemote.playerAPI?.delegate = self
//
//          self.appRemote.playerAPI?.subscribe(toPlayerState: { (result, error) in
//              if let error = error {
//
//              }else{
//               if(waitForConnect){
//                  waitForConnect = false
//                  self.commandAfterConnected()
//               }
//            }
//
//          })
     
      }
    func playerStateDidChange(_ playerState: SPTAppRemotePlayerState) {
           print("player state changed")
           print("isPaused", playerState.isPaused)
           print("track.uri", playerState.track.uri)
           print("track.name", playerState.track.name)
           print("track.imageIdentifier", playerState.track.imageIdentifier)
           print("track.artist.name", playerState.track.artist.name)
           print("track.album.name", playerState.track.album.name)
           print("track.isSaved", playerState.track.isSaved)
           print("playbackSpeed", playerState.playbackSpeed)
           print("playbackOptions.isShuffling", playerState.playbackOptions.isShuffling)
           print("playbackOptions.repeatMode", playerState.playbackOptions.repeatMode.hashValue)
           print("playbackPosition", playerState.playbackPosition)
            self.currentPlayerState = playerState
            let track = playerState.track
        
        
        
        if var trackObject:Optional = trackObj(title: track.name, artist: track.artist.name, artistUri: track.artist.uri, albumUri: track.album.uri, trackUri: track.uri, album: track.album.name ) {
            
            do{
                currentTrack = trackObject
                trackObject?.accessToken = accessToken;

                trackObject?.expiresAt = expiresAt;
                
                let jsonObj = try JSONEncoder().encode(trackObject)
                
                do {
                    if let obj = try JSONSerialization.jsonObject(with: jsonObj, options: []) as? [String: Any]{

                        let pResult: CDVPluginResult = CDVPluginResult(status: CDVCommandStatus_OK, messageAs: obj)
                        pResult.keepCallback = true
             
                        self.commandDelegate?.send(pResult, callbackId: cdvCallbackId)
                       
                       
                    }

                }catch{

                }

            }catch{
            }

        }
  

       
   
    }
  
   
    /*Overidden appdelegate methods--------------------------------------------------------------------------------------*/
//    func application(_ app: UIApplication, open url: URL, options: [UIApplication.OpenURLOptionsKey : Any] = [:]) -> Bool {
//      let parameters = appRemote.authorizationParameters(from: url);
//      print("parameters::: ", parameters);
//
//        if let access_token = parameters?["code"] {
//            self.appRemote.connectionParameters.accessToken = access_token
//            accessToken = access_token
//            print("access token: ", access_token);
////            self.appRemote.connect();
//
//        }
////        if let expires_at = parameters?["expires_in"] {
////           let convertedInt = Int(expires_at) ?? 0;
////            if(convertedInt > 0){
////                let timeNow = Int(Date().timeIntervalSince1970);
////                print("current dateTime:::", timeNow);
////                expiresAt = timeNow + convertedInt;
////                print("expires at:::", expiresAt);
////            }
////        }
////
////      } else if let error_description = parameters?[SPTAppRemoteErrorDescriptionKey] {
////          // Show the error
////      }
//     //self.appRemote.connect();
//     //self.appRemote.authorizeAndPlayURI("")
//      return true
//     }
    func scene(_ scene: UIScene, openURLContexts URLContexts: Set<UIOpenURLContext>) {
        print("^R^ scene");
      guard let url = URLContexts.first?.url else {
        return
      }
      
      self.sessionManager.application(UIApplication.shared, open: url, options: [:])
    }
    func application(_ app: UIApplication, open url: URL, options: [UIApplication.OpenURLOptionsKey : Any] = [:]) -> Bool {
        print("^R^ sessionManager", self.sessionManager.session ?? "nil")
        let parameters = self.appRemote.authorizationParameters(from: url);
        
            if let access_token = parameters?["code"] {
           
                self.appRemote.connectionParameters.accessToken = access_token
                print("^R^ Access token: ", self.appRemote.connectionParameters.accessToken!)
                accessToken = access_token
                DispatchQueue.main.asyncAfter(deadline: .now() + 2) {
                            self.appRemote.delegate = self
                          self.appRemote.connect ()
                }
            } else if let error_description = parameters?[SPTAppRemoteErrorDescriptionKey] {
                // Show the error
            }

   
      return true
    }
    func applicationWillResignActive(_ application: UIApplication) {
      if self.appRemote.isConnected {
        print("told to disconnect")
        pluginResult?.keepCallback = false;
        self.appRemote.disconnect()
        self.currentPlayerState = nil;
        self.appRemote.playerAPI?.unsubscribe(toPlayerState: {(result, error) in
            if let error = error {
              debugPrint(error.localizedDescription)
            }
        })
      }
    }
    func applicationDidBecomeActive(_ application: UIApplication) {
        if let token: String = accessToken {
            waitForConnect = true
            self.appRemote.connectionParameters.accessToken = accessToken
            print("^R^ saved token: ", self.appRemote.connectionParameters.accessToken!);
            
        }
    }
    


    ///CORDOVA PLUGIN CALLS /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// ///
        
    @objc(queueTracks:) func queueTracks(command: CDVInvokedUrlCommand){
        
    }
    
    @objc(queueTracksNPlay:) func queueTracksNPlay(command: CDVInvokedUrlCommand){
                let trackUris = command.arguments
                qTrackURIs = [];
//                for track in trackUris! {
//                    if let songs: Optional = track as! [String]{
//                        for song in songs {
//                            qTrackURIs.append(song)
//                        }
//                    }
//                }
                if(appRemote.isConnected){
                    appRemote.playerAPI?.play(qTrackURIs[qIterator], callback: qTracksCallback)
                 }else{
                    qdCommand = PLAYQUEUE
                    waitForConnect = true
                    appRemote.connect();
                }
          
    }

    @objc(queueSong:) func queueSong(command: CDVInvokedUrlCommand){
           if let trackUri: Optional = command.arguments[0] as? String ?? ""{
                              playURI = "spotify:track:"+trackUri!
                              qdCommand = QUEUESONG
                              waitForConnect = true;
                              if(appRemote.isConnected){queueSong()}
                              else{ appRemote.connect() }
          }
    }
    @objc(builtInAuthConnect:) func builtInAuthConnect(command: CDVInvokedUrlCommand){
            cdvCallbackId = command.callbackId
            if(!authorized){
                authorized = true
                //self.appRemote.authorizeAndPlayURI("")
                let requestedScopes: SPTScope = [.appRemoteControl, .userLibraryModify, .userLibraryRead, .streaming]
                self.sessionManager.initiateSession(with: requestedScopes, options: .default)
            }else {
               appRemote.connectionParameters.accessToken = accessToken
                print("correct access token: ", accessToken)
               appRemote.connect()
            }
    }
    
    @objc(play:) func play(command: CDVInvokedUrlCommand){
            print("commanded to play")
            if let trackUri: Optional = command.arguments[0] as? String ?? ""{
                print("track URI", trackUri)
                playURI = trackUri!
                qdCommand = PLAY
                waitForConnect = true;
                
                if(appRemote.isConnected){
                    self.playTrack()
                    
                }
                else{
                    appRemote.connect()
                    
                }
            }
    }
    
    @objc(resume:) func resume(command: CDVInvokedUrlCommand){
            if(appRemote.isConnected){
                resumeOrPause()
            }else{
                qdCommand = RESUME
                waitForConnect = true
                appRemote.connect();
            }
    }
    

    @objc(pause:) func pause(command: CDVInvokedUrlCommand){
                 if(appRemote.isConnected){
                    resumeOrPause()
                 }else{
                     qdCommand = PAUSE
                     waitForConnect = true
                     appRemote.connect();
                 }
    }
     
    @objc(skipNext:) func skipNext(command: CDVInvokedUrlCommand){
                if(appRemote.isConnected){
                  appRemote.playerAPI?.skip(toNext: nil)
                }else{
                  qdCommand = SKIPNEXT
                  waitForConnect = true
                  appRemote.connect();
                }
        
    }
    @objc(skipPrevious:) func skipPrevious(command: CDVInvokedUrlCommand){
            if(appRemote.isConnected){
                appRemote.playerAPI?.skip(toPrevious: nil)
            }else{
                qdCommand = SKIPBACK
                waitForConnect = true
                appRemote.connect();
            }
       
    }
    @objc(addToLibrary:) func addToLibrary(command: CDVInvokedUrlCommand){
          if let trackUri: Optional = command.arguments[0] as? String ?? ""{
                        playURI = "spotify:track:"+trackUri!
                        qdCommand = ADDLIBRARY
                        waitForConnect = true;
                        print("track to be saved: ", playURI)
                        if(appRemote.isConnected){addToLibrary()}
                        else{ appRemote.connect() }
          }
          
    }
    @objc(removeFromLibrary:) func removeFromLibrary(command: CDVInvokedUrlCommand){
      if let trackUri: Optional = command.arguments[0] as? String ?? ""{
                    playURI =  "spotify:track:"+trackUri!
                    qdCommand = REMOVEFROMLIBRARY
                    waitForConnect = true;
                    
                    if(appRemote.isConnected){removeFromLibrary()}
                    else{ appRemote.connect() }
      }
               
    }
    @objc(openArtist: ) func openArtist(command: CDVInvokedUrlCommand){

            let spotifyHook: String = currentTrack.artistUri
            let url = URL(string: spotifyHook)!
            if UIApplication.shared.canOpenURL(url){
                UIApplication.shared.open(url, options: [:], completionHandler: nil)
            }
        
    }
    @objc(openAlbum: ) func openAlbum(command: CDVInvokedUrlCommand){
        if let spotifyDestination:Optional = command.arguments[0] as? String ?? ""{
            let spotifyHook: String = spotifyDestination!
            let url = URL(string: spotifyHook)!
            if UIApplication.shared.canOpenURL(url){
                UIApplication.shared.open(url, options: [:], completionHandler: nil)
            }
        }
    }
    @objc(openTrack: ) func openTrack(command: CDVInvokedUrlCommand){
        if let spotifyDestination:Optional = command.arguments[0] as? String ?? ""{
            let spotifyHook: String = spotifyDestination!
            let url = URL(string: spotifyHook)!
            if UIApplication.shared.canOpenURL(url){
                UIApplication.shared.open(url, options: [:], completionHandler: nil)
            }
        }
    }
    @objc(openSearch:) func openSearch(comand: CDVInvokedUrlCommand){
        let spotifyHook: String = "spotify:search"
        let url = URL(string: spotifyHook)!
        
        if UIApplication.shared.canOpenURL(url){
            UIApplication.shared.open(url, options: [:], completionHandler: nil)
        }
    }
    //Fun fact the value inside @objc tells that cordova command called by cordova, it does not have to match up with the function name but it is wise to keep the standard
    @objc(openUserPlaylist:) func openUserPlaylist(comand: CDVInvokedUrlCommand){
           let spotifyHook: String = "spotify:playlists"
           let url = URL(string: spotifyHook)!
           
           if UIApplication.shared.canOpenURL(url){
               UIApplication.shared.open(url, options: [:], completionHandler: nil)
           }
    }
    ///Helpers for Cordova methods /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// /// ///
  
    func commandAfterConnected(){
        switch(qdCommand){
        case PLAY:
            self.playTrack()
        case PAUSE, RESUME:
            self.resumeOrPause()
        case SKIPNEXT:
            self.skipForward()
        case SKIPBACK:
            self.skipBackward()
        case QUEUESONG:
            self.queueSong()
        case QUEUELIST:
            self.queueTracks()
        case PLAYQUEUE:
            self.queueNPlay()
        case ADDLIBRARY:
            self.addToLibrary()
        case REMOVEFROMLIBRARY:
            self.removeFromLibrary()
        default:
            return
        }
    }
    func playTrack(){
             appRemote.playerAPI?.play(playURI, callback: nil)
    }
    func resumeOrPause(){
          if let state = currentPlayerState?.isPaused {
              if(state){
                  appRemote.playerAPI?.resume(nil)
              }else{
                  appRemote.playerAPI?.pause(nil)
              }
          }else{
              print("current player state is nil")
          }
      }
    func skipForward(){
        appRemote.playerAPI?.skip(toNext: nil)
    }
    func skipBackward(){
           appRemote.playerAPI?.skip(toPrevious: nil)
    }
    func queueSong(){
        appRemote.playerAPI?.enqueueTrackUri(playURI, callback: nil)
    }
    func queueTracks(){
            appRemote.playerAPI?.enqueueTrackUri(qTrackURIs[qIterator], callback:  qTracksCallback)
    }
    func queueNPlay(){
        if(qIterator == 0){
            appRemote.playerAPI?.play(qTrackURIs[qIterator], callback: qTracksCallback)
        }
        else{
            appRemote.playerAPI?.enqueueTrackUri(qTrackURIs[qIterator], callback:  qTracksCallback)
        }
    }
    func addToLibrary(){
        appRemote.userAPI?.addItemToLibrary(withURI: playURI, callback: {(response, error) in
            if let error = error{
             print("error", error)
            }
        })
    }
    func removeFromLibrary(){
        appRemote.userAPI?.removeItemFromLibrary(withURI: playURI, callback: {
            (reponse, error) in
            if let error = error{
                print("error", error)
            }
        })
    }
    func fetchSpotifyToken(completion: @escaping ([String: Any]?, Error?) -> Void) {
      let url = URL(string: "https://accounts.spotify.com/api/token")!
      var request = URLRequest(url: url)
      request.httpMethod = "POST"
      let spotifyAuthKey = "Basic \((SpotifyClientID + ":" + SpotifyClientSecret).data(using: .utf8)!.base64EncodedString())"
      request.allHTTPHeaderFields = ["Authorization": spotifyAuthKey, "Content-Type": "application/x-www-form-urlencoded"]
      do {
        var requestBodyComponents = URLComponents()
        let scopeAsString = stringScopes.joined(separator: " ") //put array to string separated by whitespace
        requestBodyComponents.queryItems = [URLQueryItem(name: "client_id", value: SpotifyClientID), URLQueryItem(name: "grant_type", value: "authorization_code"), URLQueryItem(name: "code", value: responseTypeCode!), URLQueryItem(name: "redirect_uri", value: SpotifyRedirectURL.absoluteString), URLQueryItem(name: "scope", value: scopeAsString),]
        request.httpBody = requestBodyComponents.query?.data(using: .utf8)
        let task = URLSession.shared.dataTask(with: request) { data, response, error in
          guard let data = data,                            // is there data
          let response = response as? HTTPURLResponse,  // is there HTTP response
          (200 ..< 300) ~= response.statusCode,         // is statusCode 2XX
          error == nil else {                           // was there no error, otherwise ...
            print("Error fetching token \(error?.localizedDescription ?? "")")
            return completion(nil, error)
          }
          let responseObject = try? JSONSerialization.jsonObject(with: data) as? [String: Any]
          print("Access Token Dictionary=", responseObject ?? "")
          completion(responseObject, nil)
        }
        task.resume()
      } catch {
        print("Error JSON serialization \(error.localizedDescription)")
      }
    }
}




// <?xml version="1.0" encoding="UTF-8"?>
// <!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
// <plist version="1.0">
// <dict>
//     <key>CFBundleDevelopmentRegion</key>
//     <string>en</string>
//     <key>LSApplicationQueriesSchemes</key>
//     <array>
//       <string>spotify</string>
//     </array>
//     <key>CFBundleDisplayName</key>
//         <string>latitunes</string>
//     <key>CFBundleExecutable</key>
//     <string>$(EXECUTABLE_NAME)</string>
//     <key>CFBundleIdentifier</key>
//     <string>$(PRODUCT_BUNDLE_IDENTIFIER)</string>
//     <key>CFBundleInfoDictionaryVersion</key>
//     <string>6.0</string>
//     <key>CFBundleName</key>
//     <string>$(PRODUCT_NAME)</string>
//     <key>CFBundlePackageType</key>
//     <string>APPL</string>
//     <key>CFBundleShortVersionString</key>
//     <string>1.0</string>
//     <key>CFBundleURLTypes</key>
//     <array>
//         <dict>
//             <key>CFBundleURLName</key>
//             <string>com.getcapacitor.capacitor</string>
//             <key>CFBundleURLSchemes</key>
//             <array>
//                 <string>capacitor</string>
//             </array>
//         </dict>
//     </array>
//     <key>CFBundleURLTypes</key>
//     <array>
//       <dict>
//         <key>CFBundleURLName</key>
//         <string>io.ionic.latitunes</string>
//         <key>CFBundleURLSchemes</key>
//         <array>
//           <string>latitunes</string>
//         </array>
//       </dict>
//     </array>
//     <key>CFBundleVersion</key>
//     <string>1</string>
//     <key>LSRequiresIPhoneOS</key>
//     <true/>
//     <key>NSAppTransportSecurity</key>
//     <dict>
//         <key>NSAllowsArbitraryLoads</key>
//         <true/>
//     </dict>
//     <key>NSCameraUsageDescription</key>
//     <string>To Take Photos and Video</string>
//     <key>NSLocationAlwaysUsageDescription</key>
//     <string>Always allow Geolocation?</string>
//     <key>NSLocationWhenInUseUsageDescription</key>
//     <string>Allow Geolocation?</string>
//     <key>NSMicrophoneUsageDescription</key>
//     <string>To Record Audio With Video</string>
//     <key>NSPhotoLibraryAddUsageDescription</key>
//     <string>Store camera photos to camera</string>
//     <key>NSPhotoLibraryUsageDescription</key>
//     <string>To Pick Photos from Library</string>
//     <key>UILaunchStoryboardName</key>
//     <string>LaunchScreen</string>
//     <key>UIMainStoryboardFile</key>
//     <string>Main</string>
//     <key>UIRequiredDeviceCapabilities</key>
//     <array>
//         <string>armv7</string>
//     </array>
//     <key>UISupportedInterfaceOrientations</key>
//     <array>
//         <string>UIInterfaceOrientationPortrait</string>
//         <string>UIInterfaceOrientationLandscapeLeft</string>
//         <string>UIInterfaceOrientationLandscapeRight</string>
//     </array>
//     <key>UISupportedInterfaceOrientations~ipad</key>
//     <array>
//         <string>UIInterfaceOrientationPortrait</string>
//         <string>UIInterfaceOrientationPortraitUpsideDown</string>
//         <string>UIInterfaceOrientationLandscapeLeft</string>
//         <string>UIInterfaceOrientationLandscapeRight</string>
//     </array>
//     <key>UIViewControllerBasedStatusBarAppearance</key>
//     <true/>
// </dict>
// </plist>



